/*
 * MPQCFragmentController.hpp
 *
 *  Created on: Aug 27, 2012
 *      Author: heber
 */

#ifndef MPQCFRAGMENTCONTROLLER_HPP_
#define MPQCFRAGMENTCONTROLLER_HPP_


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Fragmentation/Automation/SpecificFragmentController.hpp"

#include <boost/filesystem/path.hpp>

#include <fstream>
#include <string>
#include <vector>

#include "JobMarket/JobId.hpp"

#include "Jobs/MPQCData.hpp"

/** This class uses SpecificFragmentController with functions to add specificly
 * VMGJobs.
 */
class MPQCFragmentController : public SpecificFragmentController
{
public:
  MPQCFragmentController(boost::asio::io_service &io_service) :
    SpecificFragmentController(io_service),
    level(5)
  {}
  virtual ~MPQCFragmentController()
  {}

  bool addJobsFromFiles(
      const std::string &executable,
      const std::vector< boost::filesystem::path > &jobfiles);
  void getResults(std::map<JobId_t, MPQCData> &fragmentData) {
    SpecificFragmentController::getResults<MPQCData>(fragmentData);
  }

  void setLevel(const size_t _level) { level = _level; }

private:
  void parsejob(
      std::vector<FragmentJob::ptr> &jobs,
      const std::string &command,
      const std::string &filename,
      const JobId_t nextid);

private:
  //!> resolution of sampled electron density as \f$2^{\text{level}}\f$
  size_t level;
};


#endif /* MPQCFRAGMENTCONTROLLER_HPP_ */
